Package org.flowable.engine.history

# Interface HistoricProcessInstance

public interface HistoricProcessInstance
A single execution of a whole process definition that is stored permanently.

Author:
  Christian Stettler

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getBusinessKey()`
  The user provided unique reference to this process instance.
  `String`
  `getBusinessStatus()`
  The user provided business status for this process instance.
  `String`
  `getCallbackId()`
  The callback id for the process instance.
  `String`
  `getCallbackType()`
  The callback type for the process instance.
  `String`
  `getDeleteReason()`
  Obtains the reason for the process instance's deletion.
  `String`
  `getDeploymentId()`
  The deployment id of the process definition of the process instance.
  `String`
  `getDescription()`
  The description for the process instance.
  `Long`
  `getDurationInMillis()`
  The difference between `getEndTime()` and `getStartTime()` .
  `String`
  `getEndActivityId()`
  Reference to the activity in which this process instance ended.
  `Date`
  `getEndTime()`
  The time the process was ended.
  `String`
  `getId()`
  The process instance id (== as the id for the runtime `process instance`).
  `String`
  `getName()`
  The name for the process instance.
  `String`
  `getProcessDefinitionCategory()`
  The category of the process definition of the process instance.
  `String`
  `getProcessDefinitionId()`
  The process definition reference.
  `String`
  `getProcessDefinitionKey()`
  The key of the process definition of the process instance.
  `String`
  `getProcessDefinitionName()`
  The name of the process definition of the process instance.
  `Integer`
  `getProcessDefinitionVersion()`
  The version of the process definition of the process instance.
  `Map<String,Object>`
  `getProcessVariables()`
  Returns the process variables if requested in the process instance query
  `String`
  `getPropagatedStageInstanceId()`
  If this process instance runs in the context of a case and stage, this method returns it's closest parent stage instance id (the stage plan item instance id to be precise).
  `String`
  `getReferenceId()`
  The reference id for the process instance.
  `String`
  `getReferenceType()`
  The reference type for the process instance.
  `String`
  `getStartActivityId()`
  The start activity.
  `Date`
  `getStartTime()`
  The time the process was started.
  `String`
  `getStartUserId()`
  The authenticated user that started this process instance.
  `String`
  `getSuperProcessInstanceId()`
  The process instance id of a potential super process instance or null if no super process instance exists
  `String`
  `getTenantId()`
  The tenant identifier for the process instance.

- ## Method Details

  - ### getId

    String getId()
    The process instance id (== as the id for the runtime `process instance`).

  - ### getBusinessKey

    String getBusinessKey()
    The user provided unique reference to this process instance.

  - ### getBusinessStatus

    String getBusinessStatus()
    The user provided business status for this process instance.

  - ### getProcessDefinitionId

    String getProcessDefinitionId()
    The process definition reference.

  - ### getProcessDefinitionName

    String getProcessDefinitionName()
    The name of the process definition of the process instance.

  - ### getProcessDefinitionKey

    String getProcessDefinitionKey()
    The key of the process definition of the process instance.

  - ### getProcessDefinitionVersion

    Integer getProcessDefinitionVersion()
    The version of the process definition of the process instance.

  - ### getProcessDefinitionCategory

    String getProcessDefinitionCategory()
    The category of the process definition of the process instance.

  - ### getDeploymentId

    String getDeploymentId()
    The deployment id of the process definition of the process instance.

  - ### getStartTime

    Date getStartTime()
    The time the process was started.

  - ### getEndTime

    Date getEndTime()
    The time the process was ended.

  - ### getDurationInMillis

    Long getDurationInMillis()
    The difference between `getEndTime()` and `getStartTime()` .

  - ### getEndActivityId

    String getEndActivityId()
    Reference to the activity in which this process instance ended. Note that a process instance can have multiple end events, in this case it might not be deterministic which activity id will be referenced here. Use a `HistoricActivityInstanceQuery` instead to query for end events of the process instance (use the activityTYpe attribute)

  - ### getStartUserId

    String getStartUserId()
    The authenticated user that started this process instance.
    See Also:
      - `IdentityService.setAuthenticatedUserId(String)`

  - ### getStartActivityId

    String getStartActivityId()
    The start activity.

  - ### getDeleteReason

    String getDeleteReason()
    Obtains the reason for the process instance's deletion.

  - ### getSuperProcessInstanceId

    String getSuperProcessInstanceId()
    The process instance id of a potential super process instance or null if no super process instance exists

  - ### getTenantId

    String getTenantId()
    The tenant identifier for the process instance.

  - ### getName

    String getName()
    The name for the process instance.

  - ### getDescription

    String getDescription()
    The description for the process instance.

  - ### getCallbackId

    String getCallbackId()
    The callback id for the process instance.

  - ### getCallbackType

    String getCallbackType()
    The callback type for the process instance.

  - ### getReferenceId

    String getReferenceId()
    The reference id for the process instance.

  - ### getReferenceType

    String getReferenceType()
    The reference type for the process instance.

  - ### getPropagatedStageInstanceId

    String getPropagatedStageInstanceId()
    If this process instance runs in the context of a case and stage, this method returns it's closest parent stage instance id (the stage plan item instance id to be precise).
    Returns:
      the stage instance id this process instance belongs to or null, if it is not part of a case at all or is not a child element of a stage

  - ### getProcessVariables

    Map<String,Object> getProcessVariables()
    Returns the process variables if requested in the process instance query